# by lenzker

#vCenter
$vCenter = "vCENTERFQDN"

#Hostname which should be killed
$hostname = 'NAMEOFTHEVM'

#Killtype - can be soft,hard,force
$killtype = "force"

#IS VM part of a HA Cluster?
$hacluster = $true

############### DO not change from here

Connect-VIServer $vCenter | Out-Null

#Get VM
$vm = Get-VM $hostname

#Get The ESXi host where the specified VM runs
$esxi = Get-VMHost -VM $vm 

#Disable HA for this VM
If($hacluster) { $vm | Set-VM -HARestartPriority Disabled -confirm:$false }

#Get the ESXi of the specific host and store it in a variable
$esxcli = Get-EsxCli -VMhost $esxi

#Store the WorldID of the VM
$worldid = $esxcli.vm.process.list() | where{$_.Displayname -eq $hostname} | Select WorldID

#Kill the VM Process
$killstat = $esxcli.vm.process.kill($killtype,$worldid.WorldID)

If($killstat){
    '################' | Write-Host
    'VM ' + $hostname + ' has been killed ' + $killtype + 'ly' | write-Host
    '################' | Write-Host
}

#Enable HA on this VM
If($haCluster) { $vm | Set-VM -HARestartPriority ClusterRestartPriority -confirm:$false}

Disconnect-ViServer -confirm:$false